#!/usr/bin/perl
# Copyright (C) 2002-2004 NEC Corporation
# All Rights Reserved.

# RCS: $Id: add_submit.cgi,v 1.1 2006/12/22 05:31:38 shodai Exp $

## 20030328 v5.1.0 ʸĹåɲ oyama
## 20040910 v6.0.1 Jcode  Encode ˥⥸塼֤ oyama

use Encode qw/encode decode from_to/;

require "../../../lib/wbmc.pl";
require "./ldap.pl";

$found = 0;

my $add_ldif = "/opt/nec/tmp/openldap-add.ldif";
my $ldif = "";
my %record = ();

&readParam();

#եफ
$cn = $FORM{'NAME'};
$mail = ($FORM{'MAIL'});
$o = $FORM{'COMPANY'};
$ou = $FORM{'OU'};
$title = $FORM{'TITLE'};
$telephoneNumber = $FORM{'TELEPHONE'};

# 2004/9/10 euc ʸΥåԤ
@record{@print_item} = ($cn,$mail,$o,$ou,$title,$telephoneNumber);
$ret = &euc_char_check(%record);
if ($ret ne ""){
       $ret =~ s/\n/\<br\>/g;
       &showErrorPage("$ret");
       exit;
}
my $i;
foreach $i (@item){
	from_to($record{$i}, "euc-jp", "utf8");
}

# ͥå
$ret = &check_ldap_item(%record);
if ($ret ne ""){
	$ret =~ s/\n/\<br\>/g;
	&showErrorPage("$ret");
	exit;
}

#ե뤫
$suffix = &get_conf("suffix");
$rootdn = &get_conf("rootdn");
$rootpw = &get_conf("rootpw");

# ͿID
$id = &get_next_ldapid();

#Ͽ ldif ե
open(OUT,"> $add_ldif") || &showErrorPage("ѥեκ˼Ԥޤ");

$ldif = "dn: cn=$id,$suffix\n"
      . "objectclass: person\n"
      . "objectclass: pilotPerson\n"
      . "objectclass: organizationalPerson\n"
      . "objectclass: device\n"
      . "cn: $record{'cn'}\n"
      . "sn: $record{'cn'}\n"
      . "mail: $mail\n";

if ($record{'o'} ne ""){
	$ldif .= "o: $record{'o'}\n";
}
if ($record{'ou'} ne ""){
	$ldif .= "ou: $record{'ou'}\n";
}
if ($record{'title'} ne ""){
	$ldif .= "title: $record{'title'}\n";
}
if ($telephoneNumber ne ""){
	$ldif .= "telephoneNumber: $telephoneNumber\n";
}
print OUT "$ldif";

close(OUT);

system("$ldapadd -x -D \"$rootdn\" -w \"$rootpw\" -f $add_ldif >/dev/null 2>&1");
unlink($add_ldif);

system("/bin/echo $id > $ldap_uid_conf");

&showPage("./index.cgi");
#------------------------------------------------------
