#!/usr/bin/perl
# Copyright (C) 2000-2005 NEC Corporation
# All Rights Reserved.

##040913 v6.0.1 ɥ쥹ĢϿѤˡ桼ɲäή oyama
##040925 v6.0.1 RHEL3 UPDATE3 ǡfrom_to() ѻ˥ơեȤƤޤн
##050309 v6.0.5 ΤǡϿݤ˾0ܤ꤬ɽн oyama

require "../../../lib/wbmc.pl";
require join ("/", $WBMC_DOMADM_DIR, "account", "account.pl");
require "./ldap.pl";

use Encode;
use Encode::Guess qw/euc-jp shift-jis utf8/;
use MIME::Base64 qw(encode_base64);

$upload_dir = "/opt/nec/tmp";
# ꤷǥ쥯ȥ˥ǡ򥢥åץɤΥե֤̾
$uploadfile = "";
if ($err = getUploadData($upload_dir, *uploadfile)) {
    &showErrorPage("$err");
    exit(1);
}

my $suffix = &get_conf("suffix");
my $rootdn = &get_conf("rootdn");
my $rootpw = &get_conf("rootpw");
my $add_ldif = "/opt/nec/tmp/openldap-add.ldif";
my $err_mes;
my $counter = 1;

if (!open(F, '<:bytes', $uploadfile)){
  &showErrorPage("cannot open $uploadfile: $!");
  exit(-1);
}
while (<F>){
  $file .= $_;
}
close F;
$file = encode('utf8', decode('Guess', $file));
foreach (split(/\r?\n/, $file))
{
    ($cn, $mail, $o, $ou, $title, $telephoneNumber) = split(/\,/, $_);
  # ͥå
    @record{@print_item} = ($cn,$mail,$o,$ou,$title,$telephoneNumber);
    $ret = &check_ldap_item(%record);
    if ($ret ne "")
    {
	$err_mes .= "$counter ܡ$ret<br>";
	$counter++;
	next;
    }
  # ͭID 
    $id = &get_next_ldapid();
    &printldif($id, $cn, $mail, $o, $ou, $title, $telephoneNumber);
    system("/bin/echo $id > $ldap_uid_conf");
    system("$ldapadd -x -D \"$rootdn\" -w \"$rootpw\" -f $add_ldif >/dev/null 2>&1");
    unlink($add_ldif);
    $counter++;
}

unlink($uploadfile);
if ( $err_mes ne "" ){
	&showErrorPage("ʲΥǡϿ˼Ԥޤ<br>$err_mes");
} else {
	&showPage("./index.cgi");
}

#
# print user ldif
#
sub printldif
{
    my ($id, $cn, $mail, $o, $ou, $title, $tel) = @_;

if( !open(OUT, ">$add_ldif")){
  &showErrorPage("cannot open $add_ldif: $!");
  exit(-1);
}

print OUT << "EOF";
dn: cn=$id,dc=Express5800,dc=mw
objectClass: person
objectClass: pilotPerson
objectClass: organizationalPerson
objectClass: device
EOF
    print_line("cn", "$cn");
    print_line("sn", "$cn");
    print OUT "mail: $mail\n";
    print_line("o", "$o") if ($o ne "");
    print_line("ou", "$ou") if ($ou ne "");
    print_line("title", "$title") if ($title ne "");
    print OUT "telephoneNumber: $tel\n" if ($tel ne "");
    print OUT "\n";

close OUT;
}

sub print_line
{
    my ($attr, $value) = @_;

    if ($value =~ /[\x80-\xFF]/)
    {
	print OUT "$attr" . ':: ' , encode_base64 ($value,'') . "\n";
    }
    else 
    {
	print OUT "$attr: $value\n";
    }
}

