#!/usr/bin/perl

# Copyright (C) 2002-2005 NEC Corporation
# All Rights Reserved.

# RCS: $Id: aftalb.pl,v 1.1 2006/12/22 05:31:39 shodai Exp $
##20040915 v6.0.1 default gw ǥХɲ(presence Хåݡ) oyama
##20040916 v6.0.1 iANS-3.4.2 бƵưײ oyama
##20050217 v6.0.5 ifcfg-eth2 ¸ߤȤ aft/alb ưͭˤʤʤн oyama

require "../../../lib/wbmc.pl";

#
# Function
#      ϥեΥԡ(ϥե̾.old)
# Usage
#      $result = &preserve_file($file_name);
# Parameters
#      $file_name          ϥե̾(Хѥ)
# Return
#      ξ   1
#      Ԥξ   0
#

sub preserve_file 
{
    my($file_name) = @_;

    if(-f "$file_name.old"){
        if(system("/bin/rm -rf $file_name.old")>0){
            return(0);
        }
    }
    if(system("/bin/cp -fp $file_name $file_name.old")>0){
        return(0);
    }
    return(1);
}

#
# Function
#      ONBOOTѹ
# Usage
#      $result = &chg_onboot($mode, $virtual_adapter);
# Parameters
#      $mode                     ⡼(NORMAL/AFT/ALB)
#      $virtual_adapter          ۥץ
# Return
#      ξ   1
#      Ԥξ   0
#

sub chg_onboot
{
    my($mode, $virtual_adapter) = @_;

    while ($file = </etc/sysconfig/network-scripts/ifcfg-*>) {
        @ent = @line = @tmp = "";
        @ent = split(/\//, $file);
        $lockfile = $ent[4];
        next if ($lockfile eq "ifcfg-lo");
        next if ($lockfile =~ /\.old$/);
	next if ($lockfile =~ /ifcfg-eth[^01]/);

        if (!&readFile($file, $lockfile, *line)) {
            return(0);
        }

        if ($mode eq "NORMAL" and $lockfile =~ /ifcfg-eth0$/) {
            for (@line) {
                s/ONBOOT=no/ONBOOT=yes/i;
                push (@tmp, $_);
            }
        } elsif ($mode eq "NORMAL" and $lockfile =~ /ifcfg-$virtual_adapter/) {
            for (@line) {
                s/ONBOOT=yes/ONBOOT=no/i;
                push (@tmp, $_);
            }
        } elsif (($mode eq "AFT" or $mode eq "ALB") and $lockfile =~ /ifcfg-eth/) {
            for (@line) {
                s/ONBOOT=yes/ONBOOT=no/i;
                push (@tmp, $_);
            }
        } elsif (($mode eq "AFT" or $mode eq "ALB") and $lockfile =~ /ifcfg-$virtual_adapter$/) {
            for (@line) {
                s/ONBOOT=no/ONBOOT=yes/i;
                push (@tmp, $_);
            }
        } else {
            for (@line) {
                push (@tmp, $_);
            }
        }

        # ե
        return(0) if (!&preserve_file($file));

        if (!&writeFile($file, $lockfile, @tmp)) {
            system("/bin/mv -f $file.old $file");
            return(0);
        }
    }
    return(1);
}

# Function
#      GeteWay Deviceѹ(/etc/sysconfig/network)
# Usage
#      $result = &chg_gw_dev($gw_dev);
# Parameters
#      $gw_dev  GeteWay Device(eth0ȤvadȤ)
# Return
#      ξ   1
#      Ԥξ   0
#
sub chg_gw_dev {
    my($gw_dev) = @_;
    my($network_file) = '/etc/sysconfig/network';
    @lines = ();

    if (!&readFile($network_file, 'network', *lines)) {
        return(0);
    }
    for($i=0; $i<=@lines; $i++){
        if ($lines[$i] =~ /^GATEWAYDEV/){
            $lines[$i] = "GATEWAYDEV=$gw_dev\n";
        }
    }
    # ե
    return(0) if (!&preserve_file($network_file));
    if (!&writeFile($network_file, 'network', @lines)){
        system("/bin/mv -f $network_file.old $network_file");
        return(0);
    }

    return(1);
}

# Function
#      ƥ GeteWay Device ѹ
# Usage
#      $result = &chg_gw_dev(undef);
# Parameters
#      undef
# Return
#      ξ   1
#      Ԥξ   0
#
sub chg_system_gw_dev {
    my($network_file) = '/etc/sysconfig/network';
    my($gw_dev);
    my($gw_addr);
    @lines = ();

    if (!&readFile($network_file, 'network', *lines)) {
        return(0);
    }
    for($i=0; $i<=@lines; $i++){
        if ($lines[$i] =~ /^GATEWAYDEV\s*=\s*(.*)\s*/) {
            $gw_dev = $1;
        } elsif (/^GATEWAY\s*=\s*(.*)\s*/) {
            $gw_addr = $1;
        }
    }
    # ƥ Default GW ѹ
    system("/sbin/route del default >/dev/null 2>/dev/null");
    system("/sbin/route add default gw $gw_addr dev $gw_dev >/dev/null 2>/dev/null");

    return(1);
}

1;
