## obNAbvt@CΉ 2002.5.24 kima
## wbmc/adm/sysyem/backup/restore.cgi
## wbmc/bin/wbmc_backup
##  require ĂB

use POSIX qw(strftime); # for strftime();

# smbmount pfBNg
$date_str = strftime("%Y%m%d%H%M%S", localtime);
my $general_conf = "/etc/opt/nec/wbmc/backup.conf";         
my $general_conf_lock = "backup.conf";
my $tag_name = "wbmc_backup";
my $log_file = "/var/log/wbmc";
my $minimum_splitsize = (512 * 1024 * 1024);
my $split_size = 0;
eval{
        open my $fh,'<','/proc/meminfo' or die "unable to open meminfo($!)";
        while (my $line = <$fh>) {
                if ($line =~ /^MemTotal:\s*(\d+)/) {
                        $split_size = $1;
                        $split_size = $split_size * 1024;
			if ($split_size > (2 * 1024 * 1024 * 1024))
								{
									$split_size = 2 * 1024 * 1024 * 1024;
								}
                }
        }
        close($fh);
};
if ($@) {
        my $error = $@;
        &writeLog("Unable get Meminfo:$error",$tag_name,$log_file);
        $split_size = $minimum_splitsize;
};

@conf = ();
if (-f $general_conf) {
        if (!&readFile($general_conf, $general_conf_lock, *conf)) {
                &showErrorPage("$general_confɤ߹ߤ˼Ԥޤ");
                exit(1);
        }
}
my $item_fg = 0;
for($i = 0; $i < @conf; $i++) {
        if ($conf[$i] =~ /^general\s*{\s*$/) {
                $item_fg = 1;
        }
        if ($item_fg && $conf[$i] =~ /^\s*}\s*$/) {
                $item_fg = 0;
        }
        if ($item_fg && $conf[$i] =~ /^\s*TARSPLITSIZE\s*=\s*(.*)\s*$/) {
                $split_size = $1;
                if ($split_size =~ /\d+/)
                {
                        $split_size = $split_size * 1024 * 1024;
                        if ($split_size  <  $minimum_splitsize)
                        {
                                $split_size = $minimum_splitsize;
                         }
                }
        }
}

$backup_dir_smbmnt = "/mnt/_tmp_smbmnt.$date_str.$$";
# split
# $split_size = 2 * 1024 * 1024 * 1024 -1;
$split_cmd = "/usr/bin/split --bytes=${split_size} ";
$split_postfix = '._split_';

sub collect_backup_files {
  my ($dir, $base_file) = @_;
  opendir(DIRH, $dir) || return -1;
  my @files = grep(/^$base_file\Q$split_postfix\E*/, readdir(DIRH));
  closedir(DIRH);
#  print "\n>>collect!\n";
#  print join("\n", @files);
#  print "<<collect!\n";
  return @files;
}

sub remove_old_bakcup {
  my ($dir, $base_file) = @_;
  unlink("$dir/$base_file");
  my @files = &collect_backup_files($dir, $base_file);
  my $file;
  foreach $file (@files) {
    unlink("$dir/$file");
  }
}

sub chmod_backup_files {
  my ($mode, $dir, $base_file) = @_;
  print "chmod_backup_files : $dir/$base_file\n";
  chmod($mode, "$dir/$base_file");
  my @files = &collect_backup_files($dir, $base_file);
  my $file;
  my $error_flag = 0;
  foreach $file (@files) {
    print "chmod_backup_files : $dir/$file\n";
    if(!chmod($mode, "$dir/$file")) {
      $error_flag = 1;
    }
  }
  return $error_flag;
}

sub getValue {
	local($str) = @_;

	$str =~ s/^[\s]*//;
	$str =~ s/[\s]*$//;
	if ($str =~ /^"(.*)"$/) {
		$str = $1;
	}

	return($str);
}

1;
